package cn.iocoder.yudao.module.llm.service.modelassesstaskmanual;

import cn.iocoder.yudao.module.llm.controller.admin.modelassesstaskmanual.vo.ModelAssessTaskDimensionPageReqVO;
import cn.iocoder.yudao.module.llm.controller.admin.modelassesstaskmanual.vo.ModelAssessTaskDimensionSaveReqVO;
import cn.iocoder.yudao.module.llm.dal.dataobject.modelassesstaskmanual.ModelAssessTaskDimensionDO;
import cn.iocoder.yudao.module.llm.dal.mysql.modelassesstaskmanual.ModelAssessTaskDimensionMapper;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 人工打分 评估维度 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class ModelAssessTaskDimensionServiceImpl implements ModelAssessTaskDimensionService {

    @Resource
    private ModelAssessTaskDimensionMapper modelAssessTaskDimensionMapper;

    @Override
    public Long createModelAssessTaskDimension(ModelAssessTaskDimensionSaveReqVO createReqVO) {
        // 插入
        ModelAssessTaskDimensionDO modelAssessTaskDimension = BeanUtils.toBean(createReqVO, ModelAssessTaskDimensionDO.class);
        modelAssessTaskDimensionMapper.insert(modelAssessTaskDimension);
        // 返回
        return modelAssessTaskDimension.getId();
    }

    @Override
    public void updateModelAssessTaskDimension(ModelAssessTaskDimensionSaveReqVO updateReqVO) {
        // 校验存在
        validateModelAssessTaskDimensionExists(updateReqVO.getId());
        // 更新
        ModelAssessTaskDimensionDO updateObj = BeanUtils.toBean(updateReqVO, ModelAssessTaskDimensionDO.class);
        modelAssessTaskDimensionMapper.updateById(updateObj);
    }

    @Override
    public void deleteModelAssessTaskDimension(Long id) {
        // 校验存在
        validateModelAssessTaskDimensionExists(id);
        // 删除
        modelAssessTaskDimensionMapper.deleteById(id);
    }

    private void validateModelAssessTaskDimensionExists(Long id) {
        if (modelAssessTaskDimensionMapper.selectById(id) == null) {
            throw exception(MODEL_ASSESS_TASK_DIMENSION_NOT_EXISTS);
        }
    }

    @Override
    public ModelAssessTaskDimensionDO getModelAssessTaskDimension(Long id) {
        return modelAssessTaskDimensionMapper.selectById(id);
    }

    @Override
    public PageResult<ModelAssessTaskDimensionDO> getModelAssessTaskDimensionPage(ModelAssessTaskDimensionPageReqVO pageReqVO) {
        return modelAssessTaskDimensionMapper.selectPage(pageReqVO);
    }

}